package es.simTacticat.forwarder;
import continuousServiceSimulation.util.Parameters;
import drcl.comp.ACARuntime;
import drcl.comp.Port;
import drcl.comp.Contract;
import drcl.util.random.ExponentialDistribution;


public class ForwardClient extends drcl.inet.application.SUDPApplication //implements Runnable
{
	final static int CONNECT = 0, OP = 1, KEEPALIVE = 2, SINCRO = 3, ACCEPT = 4;
	double myrand;
	long serverId;
	int serverPort;
	boolean conectado =false;
	int syncs = 0;
	
	
	public ForwardClient ()//ACARuntime s)
	{
		super ();
	}
	
	public ForwardClient (String id_)//, ACARuntime s)
	{
		super (id_);
	}
	
	public void send_op (long dst, int port)
	{
		debug ("CLIENTE manda OPERACION");
		sleepFor(0.001);
		sendmsg (new Paquete (OP, getTime (), 0), 300, dst, port);
	}
	
	public void send_ka (long dst, int port)
	{
		sendmsg (new Paquete (KEEPALIVE, getTime (), 0), 300, dst, port);
	}
		
	public void send_connect (long dst, int port)
	{
		debug ("CLIENTE manda connect");
		serverId = dst;
		serverPort = port;
		sendmsg (new Paquete (CONNECT, getTime (), 0), 250, dst, port);
	}
	
	
	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		long src = getPeerAddress(data_);
		int port = getPeerPort (data_);
		Paquete pkt = (Paquete) getContent (data_);
		if (pkt.type == ACCEPT)
		{
			this.sleepFor(0.001);
			conectado = true;
			debug ("CLIENTE conectado");
		}
		if (pkt.type == SINCRO)
		{
			syncs ++;
			double time = getTime()-pkt.time+pkt.t2;
			time = time*1000;
			debug ("CLIENTE recibe sincronizacion :  "+time);
			sincronizarme ();
		}
	}
	
	public void esperar ()
	{
		sleepFor (2);
		debug ("*****************************");
	}
	
	
	public void sincronizarme ()
	{
		this.sleepFor(0.001);
		
	}
}
