package es.simTacticat.forwarder;

import java.util.Vector;
import drcl.comp.Contract;
import drcl.comp.Port;

public class ServerMaestroForwarder extends drcl.inet.application.SUDPApplication
{
	
	final static int CONNECT = 0, OP = 1, KEEPALIVE = 2, SINCRO = 3, ACCEPT = 4, ADD = 5, OPADV = 6;
	//ThreadServer ts;
	//ClientRef cr[] = new ClientRef[50];
	Vector cr = new Vector();
	int syncs = 0;
	
	public ServerMaestroForwarder ()
	{
		super ();
	}
	
	public ServerMaestroForwarder (String id_)
	{
		super (id_);
	}
	
	public void send_syncro(long dst, int dport)
	{
		debug ("Enviando sincronizacion numero "+ syncs+" al destino: "+dst);
		sendmsg(new Paquete(SINCRO, getTime(),0), 600/*size*/, dst, dport);
		//debug("Sincronizando a "+dst);
	}
	public void esperar ()
	{
		sleepFor (3);
		debug ("******************************************************");
		debug ("******************************************************");
	}
	
	public void conectar (ClientRef c)
	{
		this.sleepFor(0.001);
		//debug("A");
		boolean enc = false;
		//debug("A");
		int fp = -1;
		//debug("A");
		for(int i=0; i<cr.size();i++)
		{
			ClientRef ci = (ClientRef)cr.get(i);
			if(ci.direccion == c.direccion)
			{
				enc = true;
				//debug ("Cliente existente");
				break;
			}
			
		}
		//debug("A");
		if (!enc) 
		{
			//debug("A");
			//ClientRef cfp= (ClientRef)cr.get(fp);
			cr.add(c);
			//debug ("QWE ::::" + c.toString());
			//debug("WQE::::"+ c.direccion+" ::: "+c.puerto);
			//sendmsg(new Paquete(SINCRO,getTime()), 10/*size*/, c.direccion, c.puerto);
			debug("Acepto cliente: "+c.direccion);
			send_accept (c.direccion, c.puerto);
			//sincronizar ();
			//debug ("He sincronizado a todos");
			//debug("A");
		}
	}
	
	public void avanzarOp()
	{
		this.sleepFor(0.001);
		sincronizar ();
	}
	
	public void sincronizar ()
	{
		debug ("MAESTRO sincroniza");
		this.sleepFor(0.001*cr.size());
		for (int i = 0; i < cr.size(); i++)
		{
			
			syncs ++;
			ClientRef c = (ClientRef)cr.get(i);
			send_syncro(c.direccion, c.puerto);
		}
	}
	
	
	public void send_accept (long dst, int port)
	{
		sendmsg(new Paquete(ACCEPT,getTime(),0), 400/*size*/, dst, port);		
	}
	
	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		ClientRef c = new ClientRef (getPeerAddress(data_), getPeerPort(data_));
		Paquete pkt = (Paquete)getContent(data_);
		
		if (pkt.type == CONNECT)
		{
			conectar (c);
		}
		if (pkt.type == OP)
		{
			debug ("SERVER recibe operacion");
			avanzarOp ();
		}
		if (pkt.type == ADD)
		{
			sleepFor(0.002);
			send_accept (c.direccion,c.puerto);
		}
	}


}
