package es.simTacticat.replicated;
import continuousServiceSimulation.util.Parameters;
import drcl.comp.ACARuntime;
import drcl.comp.Port;
import drcl.comp.Contract;
import drcl.util.random.ExponentialDistribution;
import es.simTacticat.replicated.Paquete;


public class ReplicatedClient extends drcl.inet.application.SUDPApplication //implements Runnable
{
	final static int CONNECT = 0, OP = 1, KEEPALIVE = 2, SINCRO = 3, ACCEPT = 4;
	double myrand;
	//ThreadKeepCliente tk;
	long serverId;
	int serverPort;
	boolean conectado =false;
	int syncs = 0;
	//private ACARuntime sim;
    //private ExponentialDistribution random;
	
	
	public ReplicatedClient ()//ACARuntime s)
	{
		super ();
		//sim=s;
		//tk = new ThreadKeepCliente(this);
		//Parameters params = Parameters.getInstance();
		//this.random = new ExponentialDistribution(params.load, 3);
		
	}
	
	public ReplicatedClient (String id_)//, ACARuntime s)
	{
		super (id_);
		//sim=s;
		//tk = new ThreadKeepCliente(this);
		//Parameters params = Parameters.getInstance();
		//this.random = new ExponentialDistribution(params.load, 3);
	}
	
	public void send_op (long dst, int port)
	{
		sleepFor(0.005);
		//debug ("Sending operation");
		sendmsg (new Paquete (OP, getTime ()), 300, dst, port);
	}
	
	public void send_op_ligera (long dst, int port)
	{
		debug("OPERACION LIGERA");
		sleepFor(0.005);
		//debug ("Sending operation");
		sendmsg (new Paquete (5, getTime ()), 300, dst, port);
	}
	
	public void send_ka (long dst, int port)
	{
		//debug ("Sending keepAlive");
		sendmsg (new Paquete (KEEPALIVE, getTime ()), 300, dst, port);
	}
		
	public void send_connect (long dst, int port)
	{
		//debug ("sending connect");
		serverId = dst;
		serverPort = port;
		sendmsg (new Paquete (CONNECT, getTime ()), 250, dst, port);
		
	}

	public void dataArriveAtDownPort (Object data_, Port downport_)
	{
		//debug("QWERTY");
		long src = getPeerAddress(data_);
		int port = getPeerPort (data_);
		Paquete pkt = (Paquete) getContent (data_);
		//debug("QWERTY");
		if (pkt.type == ACCEPT)
		{
			//tc.dir=src;
			//tc.port=port;
			this.sleepFor(0.002);
			conectado = true;
			debug ("Conectado, inicia simulacion");
			//thread_ppal (src, port);
			//tk.start();
			//tk.run();
		}
		if (pkt.type == SINCRO)
		{
			syncs ++;
			double time = getTime()-pkt.time+pkt.time2;
			debug ("He recibido sincronizacion: "+(time*1000));
			sincronizarme ();
		}
	}
	

	
	public void sincronizarme ()
	{
		this.sleepFor(0.003);
		
	}
}
